
MEMORY {

// 64MB of dram starting at 0x00000000

    dram_rsvd1   : ORIGIN = 0x00000000, LENGTH = 256
    dram_reset   : ORIGIN = .,	        LENGTH = 256
    dram_rsvd2   : ORIGIN = ., 	        LENGTH = 16K-256-256
    dram_memory  : ORIGIN = ., 	 	LENGTH = 64M-16K

// 16MB of flash starting at 0xfe000000

    flash_rsvd1  : ORIGIN = 0xfe000000, LENGTH = 64K
    flash_memory : ORIGIN = .,          LENGTH = 16M-64K
    flash_rsvd2  : ORIGIN = .,          LENGTH = 0

// alternate reset vector at 0xfff00100
    alt_reset    : ORIGIN = 0xfff00100, LENGTH = 256
}

DEFAULTS {

    heap_reserve = 1M
    stack_reserve = 512K

}
//
// Program layout for running out of RAM.
//
//

SECTIONS
{
    .PPC.EMB.sdata0 	            	    	    ABS : > dram_memory
    .PPC.EMB.sbss0                            CLEAR ABS : > .

    .text  			            		: > dram_memory
    .vletext 				    		: > .
    .syscall 				    		: > .
    .secinfo 				    		: > .
    .rodata 				    		: > .
    .toc 				    		: > .
    .sdata2 				    		: > .
    .opd 				    		: > .
    .fixaddr			 	   		: > .
    .fixtype						: > .

    .sdabase 		        	      ALIGN(16) : > dram_memory	
    .sdata 						: > .
    .sbss 						: > .
    .data 						: > .
    .bss 		  				: > .
    .ghcovfz 					  CLEAR	: > .
    .ghcovcz 					  CLEAR	: > .
    .ghcovdz 					  CLEAR	: > .
    .heap                  ALIGN(16) PAD(heap_reserve)  : > .   
    .stack                 ALIGN(16) PAD(stack_reserve) : > .

//
// These special symbols mark the bounds of RAM and ROM memory.
// They are used by the MULTI debugger.
//
    __ghs_ramstart  = MEMADDR(dram_rsvd1);
    __ghs_ramend    = MEMENDADDR(dram_memory);
    __ghs_romstart  = MEMADDR(flash_rsvd1);
    __ghs_romend    = MEMENDADDR(flash_rsvd2);
    
}
